#ifndef IMG_H
#define IMG_H

#include "aliases.h"
#include "mem_arena.h"
#include <stdbool.h>

typedef struct img Image;
struct img {
  u64 width;
  u64 height;
  u8 *buf;
};

typedef struct colour Colour;
struct colour {
  u8 r;
  u8 g;
  u8 b;
  u8 a;
};

bool init_image(Arena *arena, Image *img);
void set_pixel(Image *img, u64 x, u64 y, Colour colour);
void clear_image(Image *img, Colour colour);
void draw_line(Image *img, u64 x0, u64 y0, u64 x1, u64 y1, Colour colour);
void save_image(const Image *img, const char *filename);

#endif // IMG_H
